Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/BenchmarkSuitePushInstanceProvider.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/BenchmarkSuitePushInstanceProvider.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/BenchmarkSuitePushInstanceProvider.cs	(revision 14602)
@@ -0,0 +1,12 @@
+﻿namespace HeuristicLab.BenchmarkSuite {
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+  using HeuristicLab.Problems.Instances;
+
+  public class BenchmarkSuitePushInstanceProvider : BenchmarkSuiteInstanceProvider<IPushData> {
+    public override IPushData LoadData(IDataDescriptor descriptor) {
+      var benchmarkSuiteDataDescriptor = descriptor as IBenchmarkSuiteDataDescriptor;
+
+      return benchmarkSuiteDataDescriptor.CreatePushData();
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj	(revision 14602)
@@ -8,6 +8,6 @@
     <AppDesignerFolder>Properties</AppDesignerFolder>
     <RootNamespace>HeuristicLab.BenchmarkSuite</RootNamespace>
-    <AssemblyName>HeuristicLab.BenchmarkSuite</AssemblyName>
-    <TargetFrameworkVersion>v4.5.2</TargetFrameworkVersion>
+    <AssemblyName>HeuristicLab.Problems.ProgramSynthesis.BenchmarkSuite</AssemblyName>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
     <ProjectTypeGuids>{3AC096D0-A1C2-E12C-1390-A8335801FDAB};{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}</ProjectTypeGuids>
@@ -17,4 +17,5 @@
     <IsCodedUITest>False</IsCodedUITest>
     <TestProjectType>UnitTest</TestProjectType>
+    <TargetFrameworkProfile />
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
@@ -22,13 +23,14 @@
     <DebugType>full</DebugType>
     <Optimize>false</Optimize>
-    <OutputPath>bin\Debug\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
     <DefineConstants>DEBUG;TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <LangVersion>5</LangVersion>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
     <DebugType>pdbonly</DebugType>
     <Optimize>true</Optimize>
-    <OutputPath>bin\Release\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
     <DefineConstants>TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
@@ -42,4 +44,8 @@
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Core-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.PluginInfrastructure-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Problems.Instances-3.3">
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances-3.3.dll</HintPath>
@@ -48,5 +54,7 @@
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Random-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="Microsoft.VisualBasic" />
     <Reference Include="System" />
+    <Reference Include="System.IO.Compression" />
   </ItemGroup>
   <Choose>
@@ -63,12 +71,55 @@
   </Choose>
   <ItemGroup>
-    <Compile Include="ArtificialDataDescriptor.cs" />
     <Compile Include="BenchmarkSuiteDataDescriptor.cs" />
-    <Compile Include="Example.cs" />
+    <Compile Include="BenchmarkSuiteInstanceProvider.cs" />
+    <Compile Include="BenchmarkSuitePushInstanceProvider.cs" />
+    <Compile Include="IBenchmarkSuiteDataDescriptor.cs" />
+    <Compile Include="ProblemData\ReplaceSpaceWithNewlinePushData.cs" />
+    <Compile Include="ProblemData\PigLatinPushData.cs" />
+    <Compile Include="ProblemData\NumberIoPushData.cs" />
+    <Compile Include="ProblemData\NegativeToZeroPushData.cs" />
+    <Compile Include="ProblemData\MirrorImagePushData.cs" />
+    <Compile Include="ProblemData\MedianPushData.cs" />
+    <Compile Include="ProblemData\LastIndexOfZeroPushData.cs" />
+    <Compile Include="ProblemData\GradePushData.cs" />
+    <Compile Include="ProblemData\ChecksumPushData.cs" />
+    <Compile Include="ProblemData\CollatzNumbersPushData.cs" />
+    <Compile Include="ProblemData\CompareStringLengthsPushData.cs" />
+    <Compile Include="ProblemData\ForLoopIndexPushData.cs" />
+    <Compile Include="ProblemData\EvenSquaresPushData.cs" />
+    <Compile Include="ProblemData\DoubleLettersPushData.cs" />
+    <Compile Include="ProblemData\DigitsPushData.cs" />
+    <Compile Include="ProblemData\Data.cs" />
+    <Compile Include="ProblemData\Example.cs" />
+    <Compile Include="Plugin.cs" />
+    <Compile Include="ProblemData\IData.cs" />
+    <Compile Include="ProblemData\IPushData.cs" />
+    <Compile Include="ProblemData\CountOddsPushData.cs" />
+    <Compile Include="Problems\ReplaceSpaceWithNewline.cs" />
+    <Compile Include="Problems\PigLatin.cs" />
+    <Compile Include="Problems\NumberIo.cs" />
+    <Compile Include="Problems\NegativeToZero.cs" />
+    <Compile Include="Problems\MirrorImage.cs" />
+    <Compile Include="Problems\Median.cs" />
+    <Compile Include="Problems\LastIndexOfZero.cs" />
+    <Compile Include="Problems\Grades.cs" />
+    <Compile Include="Problems\ForLoopIndex.cs" />
+    <Compile Include="Problems\EvenSquares.cs" />
+    <Compile Include="Problems\DoubleLetters.cs" />
+    <Compile Include="Problems\Checksum.cs" />
+    <Compile Include="Problems\CollatzNumbers.cs" />
+    <Compile Include="Problems\CompareStringLengths.cs" />
+    <Compile Include="Problems\Digits.cs" />
     <Compile Include="Problems\CountOdds.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
   <ItemGroup>
-    <Folder Include="Data\" />
+    <ProjectReference Include="..\HeuristicLab.Algorithms.PushGP\HeuristicLab.Algorithms.PushGP.csproj">
+      <Project>{368D1303-470C-4F31-91F2-0FAD379DAA45}</Project>
+      <Name>HeuristicLab.Algorithms.PushGP</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="Data\BenchmarkExamples.zip" />
   </ItemGroup>
   <Choose>
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj.user
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj.user	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj.user	(revision 14602)
@@ -2,5 +2,5 @@
 <Project ToolsVersion="14.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
   <PropertyGroup>
-    <ProjectView>ShowAllFiles</ProjectView>
+    <ProjectView>ProjectFiles</ProjectView>
   </PropertyGroup>
 </Project>
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/IBenchmarkSuiteDataDescriptor.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/IBenchmarkSuiteDataDescriptor.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/IBenchmarkSuiteDataDescriptor.cs	(revision 14602)
@@ -0,0 +1,10 @@
+﻿namespace HeuristicLab.BenchmarkSuite {
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+  using HeuristicLab.Problems.Instances;
+
+  public interface IBenchmarkSuiteDataDescriptor : IDataDescriptor {
+    IData CreateData();
+
+    IPushData CreatePushData();
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Plugin.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Plugin.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Plugin.cs	(revision 14602)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Author: Patrik Kimmeswegner
+ */
+
+#endregion
+
+namespace HeuristicLab.BenchmarkSuite {
+  using HeuristicLab.PluginInfrastructure;
+
+  [Plugin("HeuristicLab.Problems.ProgramSynthesis.BenchmarkSuite", "1.0")]
+  [PluginFile("HeuristicLab.Problems.ProgramSynthesis.BenchmarkSuite.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
+  [PluginDependency("HeuristicLab.Random", "3.3")]
+  public class PushGpPlugin : PluginBase {
+
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/ChecksumPushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/ChecksumPushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/ChecksumPushData.cs	(revision 14602)
@@ -0,0 +1,35 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class ChecksumPushData : Data<string, string>, IPushData {
+    public ChecksumPushData(Example<string, string>[] training, Example<string, string>[] test)
+      : base(training, test, 0, 256 * 10) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      var asciiValues = GetAsciiValues(this.Training[index].Input);
+      interpreter.IntegerStack.Push(asciiValues);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      var asciiValues = GetAsciiValues(this.Test[index].Input);
+      interpreter.IntegerStack.Push(asciiValues);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data => GetAsciiResultDifference(data, interpreter.IntegerStack));
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data => GetAsciiResultDifference(data, interpreter.IntegerStack));
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/CollatzNumbersPushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/CollatzNumbersPushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/CollatzNumbersPushData.cs	(revision 14602)
@@ -0,0 +1,33 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class CollatzNumbersPushData : Data<long, long>, IPushData {
+    public CollatzNumbersPushData(Example<long, long>[] training, Example<long, long>[] test)
+      : base(training, test, 0, 260) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Training[index].Input);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Test[index].Input);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data => data - interpreter.IntegerStack.Top);
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data => data - interpreter.IntegerStack.Top);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/CompareStringLengthsPushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/CompareStringLengthsPushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/CompareStringLengthsPushData.cs	(revision 14602)
@@ -0,0 +1,32 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class CompareStringLengthsPushData : Data<string[], bool>, IPushData {
+    public CompareStringLengthsPushData(Example<string[], bool>[] training, Example<string[], bool>[] test)
+      : base(training, test, 0, test.Length) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.NameStack.Push(Training[index].Input);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.NameStack.Push(Test[index].Input);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.BooleanStack,
+        index,
+        this.Training,
+        data => data == interpreter.BooleanStack.Top ? 1 : 0);
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.BooleanStack,
+        index, this.Test,
+        data => data == interpreter.BooleanStack.Top ? 1 : 0);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/CountOddsPushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/CountOddsPushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/CountOddsPushData.cs	(revision 14602)
@@ -0,0 +1,33 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class CountOddsPushData : Data<long[], long>, IPushData {
+    public CountOddsPushData(Example<long[], long>[] training, Example<long[], long>[] test)
+      : base(training, test, 0, 50) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Training[index].Input);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Test[index].Input);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data => data - interpreter.IntegerStack.Top);
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Test,
+        data => data - interpreter.IntegerStack.Top);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/Data.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/Data.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/Data.cs	(revision 14602)
@@ -0,0 +1,58 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+  using System;
+  using System.Linq;
+
+  using HeuristicLab.Algorithms.PushGP.Stack;
+
+  public class Data<TIn, TOut> : IData {
+    public readonly Example<TIn, TOut>[] Training;
+    public readonly Example<TIn, TOut>[] Test;
+
+    public Data(Example<TIn, TOut>[] training, Example<TIn, TOut>[] test, double bestResult, double worstResult) {
+      this.Training = training;
+      this.Test = test;
+      this.WorstResult = worstResult;
+      this.BestResult = bestResult;
+    }
+
+    public int TrainingCount { get { return Training.Length; } }
+    public int TestCount { get { return Test.Length; } }
+
+    public double WorstResult { get; private set; }
+    public double BestResult { get; private set; }
+
+    protected double CompareOutput<TStack>(IStack<TStack> stack, int index, Example<TIn, TOut>[] data, Func<TOut, double> differ) {
+      if (stack.IsEmpty)
+        return this.WorstResult;
+
+      var diff = differ(data[index].Output);
+      return diff == long.MinValue ? this.WorstResult : Math.Min(Math.Abs(diff), this.WorstResult);
+    }
+
+    protected static long[] GetAsciiValues(string str) {
+      return str.Select(c => (long)c).ToArray();
+    }
+
+    protected static double GetAsciiResultDifference(string data, IStack<long> stack) {
+      var resultCount = Math.Min(data.Length, stack.Count);
+      var resultValues = stack.Pop(resultCount);
+
+      return Math.Abs(GetAsciiValues(data).Sum() - resultValues.Sum());
+    }
+
+    protected static double GetFloatResultDifference(double data, IStack<double> stack) {
+      return Math.Abs(data - stack.Pop());
+    }
+
+    protected static double GetIntResultDifference(long data, IStack<long> stack) {
+      return Math.Abs(data - stack.Pop());
+    }
+
+    protected static double GetIntResultDifference(long[] data, IStack<long> stack) {
+      var resultCount = Math.Min(data.Length, stack.Count);
+      var resultValues = stack.Pop(resultCount);
+
+      return Math.Abs(data.Sum() - resultValues.Sum());
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/DigitsPushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/DigitsPushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/DigitsPushData.cs	(revision 14602)
@@ -0,0 +1,34 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class DigitsPushData : Data<long, long[]>, IPushData {
+    public DigitsPushData(Example<long, long[]>[] training, Example<long, long[]>[] test)
+      : base(training, test, 0, 19 * 15) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Training[index].Input);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Test[index].Input);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data => GetIntResultDifference(data, interpreter.IntegerStack));
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Test,
+        data => GetIntResultDifference(data, interpreter.IntegerStack));
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/DoubleLettersPushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/DoubleLettersPushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/DoubleLettersPushData.cs	(revision 14602)
@@ -0,0 +1,35 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class DoubleLettersPushData : Data<string, string>, IPushData {
+    public DoubleLettersPushData(Example<string, string>[] training, Example<string, string>[] test)
+      : base(training, test, 0, 128 * 70) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      var asciiValues = GetAsciiValues(this.Training[index].Input);
+      interpreter.IntegerStack.Push(asciiValues);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      var asciiValues = GetAsciiValues(this.Training[index].Input);
+      interpreter.IntegerStack.Push(asciiValues);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data => GetAsciiResultDifference(data, interpreter.IntegerStack));
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Test,
+        data => GetAsciiResultDifference(data, interpreter.IntegerStack));
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/EvenSquaresPushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/EvenSquaresPushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/EvenSquaresPushData.cs	(revision 14602)
@@ -0,0 +1,34 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class EvenSquaresPushData : Data<long, long[]>, IPushData {
+    public EvenSquaresPushData(Example<long, long[]>[] training, Example<long, long[]>[] test)
+      : base(training, test, 0, 100000) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Training[index].Input);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Test[index].Input);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data => GetIntResultDifference(data, interpreter.IntegerStack));
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Test,
+        data => GetIntResultDifference(data, interpreter.IntegerStack));
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/Example.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/Example.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/Example.cs	(revision 14602)
@@ -0,0 +1,6 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+  public class Example<TIn, TOut> {
+    public TIn Input { get; set; }
+    public TOut Output { get; set; }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/ForLoopIndexPushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/ForLoopIndexPushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/ForLoopIndexPushData.cs	(revision 14602)
@@ -0,0 +1,34 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class ForLoopIndexPushData : Data<long[], long[]>, IPushData {
+    public ForLoopIndexPushData(Example<long[], long[]>[] training, Example<long[], long[]>[] test)
+      : base(training, test, 0, 50 * 15) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Training[index].Input);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Test[index].Input);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data => GetIntResultDifference(data, interpreter.IntegerStack));
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Test,
+        data => GetIntResultDifference(data, interpreter.IntegerStack));
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/GradePushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/GradePushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/GradePushData.cs	(revision 14602)
@@ -0,0 +1,33 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class GradePushData : Data<long[], string>, IPushData {
+    public GradePushData(Example<long[], string>[] training, Example<long[], string>[] test)
+      : base(training, test, 0, 5) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(this.Training[index].Input);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(this.Test[index].Input);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data => GetAsciiResultDifference(data, interpreter.IntegerStack));
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data => GetAsciiResultDifference(data, interpreter.IntegerStack));
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/IData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/IData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/IData.cs	(revision 14602)
@@ -0,0 +1,9 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+  public interface IData {
+    int TrainingCount { get; }
+    int TestCount { get; }
+
+    double WorstResult { get; }
+    double BestResult { get; }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/IPushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/IPushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/IPushData.cs	(revision 14602)
@@ -0,0 +1,11 @@
+﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+namespace HeuristicLab.BenchmarkSuite.ProblemData {
+
+  public interface IPushData : IData {
+    void ApplyTrainingInput(IPushGpInterpreter interpreter, int index);
+    void ApplyTestInput(IPushGpInterpreter interpreter, int index);
+    double CompareTrainingOutput(IPushGpInterpreter interpreter, int index);
+    double CompareTestOutput(IPushGpInterpreter interpreter, int index);
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/LastIndexOfZeroPushData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/LastIndexOfZeroPushData.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ProblemData/LastIndexOfZeroPushData.cs	(revision 14602)
@@ -0,0 +1,33 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+
+  public class LastIndexOfZeroPushData : Data<long[], long>, IPushData {
+    public LastIndexOfZeroPushData(Example<long[], long>[] training, Example<long[], long>[] test)
+      : base(training, test, 0, 50) {
+    }
+
+    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Training[index].Input);
+    }
+
+    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
+      interpreter.IntegerStack.Push(Test[index].Input);
+    }
+
+    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Training,
+        data => data - interpreter.IntegerStack.Top);
+    }
+
+    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
+      return this.CompareOutput(
+        interpreter.IntegerStack,
+        index,
+        this.Test,
+        data => data - interpreter.IntegerStack.Top);
+    }
+  }
+}
